// CrystalMarkDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "wbemcli.h"     // WMI interface declarations

#include "resource.h"

#include <process.h>

#include "../CrystalMarkShare/ISysInfo.h"
#include "../CrystalMarkShare/ItemID.h"
#include "../CrystalMarkShare/Share.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define USER_AGENT "CrystalMark08"

/*
#define LOCAL

#ifdef LOCAL
#define SERVER_NAME "localhost"
#define SCRIPT_PATH "/~hiyohiyo/SysInfo/regist.php"
#endif 
*/

#ifndef LOCAL
#define SERVER_NAME "musee.cims.hokudai.ac.jp"
#define SCRIPT_PATH "/~hiyohiyo/SysInfo/regist.php"
#endif


UINT WMIInit(LPVOID Status);
void GetCPUID(DWORD id,DWORD* A,DWORD* B,DWORD* C,DWORD* D);

//void WMIInit(void* Status);

typedef ISysInfo* (*_CreateSysInfo_) (DWORD);
typedef void (*_DestroySysInfo_) (ISysInfo*);

BOOL CCrystalMarkDlg::ConnectSysInfo(DWORD Mode)
{
	hSysInfoLib = LoadLibrary("SysInfo.dll");
	if(hSysInfoLib != NULL){
		_CreateSysInfo_ pCreateSysInfo = (_CreateSysInfo_) GetProcAddress (hSysInfoLib,"CreateSysInfo");
		SysInfo = pCreateSysInfo(Mode);
		return TRUE;
	}else{
		MessageBox("Not found \"SysInfo.dll\".");
		exit(0);
		return FALSE;
	}
}

BOOL CCrystalMarkDlg::DisconnectSysInfo()
{
	if(hSysInfoLib !=NULL){
		_DestroySysInfo_ pDestroySysInfo = (_DestroySysInfo_) GetProcAddress (hSysInfoLib,"DestroySysInfo");
		pDestroySysInfo(SysInfo);
		FreeLibrary(hSysInfoLib);
		hSysInfoLib = NULL;
		SysInfo = NULL;
		return TRUE;
	}else{
		return FALSE;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCrystalMarkDlg _CAO

CCrystalMarkDlg::CCrystalMarkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCrystalMarkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCrystalMarkDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	hSysInfoLib = NULL;
	SysInfo = NULL;
}

CCrystalMarkDlg::~CCrystalMarkDlg()
{
#ifndef CRYSTAL_SYS_INFO
	if(m_MarkDlg != NULL){		delete m_MarkDlg;}
	if(m_RankingDlg != NULL){	delete m_RankingDlg;}
#endif
	if(m_SystemDlg != NULL){	delete m_SystemDlg;}
	if(m_CPUDlg != NULL){		delete m_CPUDlg;}
	if(m_FeatureDlg != NULL){	delete m_FeatureDlg;}
	if(m_DeviceDlg != NULL){	delete m_DeviceDlg;}
	if(m_PCIDlg != NULL){		delete m_PCIDlg;}
	if(m_DiskDlg != NULL){		delete m_DiskDlg;}
	if(m_DllDlg != NULL){		delete m_DllDlg;}
	if(m_InfoDlg != NULL){		delete m_InfoDlg;}
	if(m_BgDlg != NULL){		delete m_BgDlg;}
	if(m_ExpertDlg != NULL){	delete m_ExpertDlg;}

	gBackBitmap.Detach();
	gBackBitmap.DeleteObject();
	gBackBrush.DeleteObject();

	if(m_BackBitmap != NULL){	delete m_BackBitmap;}
	if(m_BackBrush != NULL){	delete m_BackBrush;}

	DisconnectSysInfo();
}

void CCrystalMarkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCrystalMarkDlg)
	DDX_Control(pDX, IDC_TAB, m_Tab);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCrystalMarkDlg, CDialog)
	//{{AFX_MSG_MAP(CCrystalMarkDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, OnSelchangeTab)
	ON_COMMAND(IDM_CPU, OnCpu)
	ON_COMMAND(IDM_DEVICE, OnDevice)
	ON_COMMAND(IDM_DISK, OnDisk)
	ON_COMMAND(IDM_FEATURE, OnFeature)
	ON_COMMAND(IDM_PCI, OnPci)
	ON_COMMAND(IDM_SYSTEM, OnSystem)
	ON_COMMAND(IDM_INFO, OnInfo)
	ON_COMMAND(IDM_CRYSTAL_DEW_WORLD, OnCrystalDewWorld)
	ON_COMMAND(IDM_MARK, OnMark)
	ON_COMMAND(IDM_RANKING, OnRanking)
	ON_COMMAND(IDM_HELP_HTML, OnHelpHtml)
	ON_COMMAND(IDM_HELP_TEXT, OnHelpText)
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_COMMAND(IDM_ENGLISH, OnEnglish)
	ON_COMMAND(IDM_JAPANESE, OnJapanese)
	ON_COMMAND(IDM_CPU_SUPPORT, OnCpuSupport)
	ON_COMMAND(IDM_MARK_INI, OnMarkIni)
	ON_COMMAND(IDM_SYS_INFO_TEXT, OnSysInfoText)
	ON_COMMAND(IDM_DLL, OnDll)
	ON_COMMAND(IDM_BG, OnBg)
	ON_COMMAND(IDM_EXPERT, OnExpert)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCrystalMarkDlg bZ[W nh

BOOL CCrystalMarkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	InitCommonControls();

	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
//	SetIcon(m_hIcon, FALSE);		// ACRݒ

	DebugInfo(CRYSTAL_MARK_INIT_START);

	DebugInfo(SYS_INFO_INIT_START);

	ConnectSysInfo(MODE_CPU | MODE_PCI | MODE_WIN);

	DebugInfo(SYS_INFO_INIT_END);

	// INI t@C̏ꏊݒ
	char* ptrEnd;
	char str[256];
	::GetModuleFileName(NULL, m_ini, MAX_PATH);
	if ( (ptrEnd = strrchr(m_ini, '.')) != NULL ){*ptrEnd = '\0';strcat(m_ini, ".ini");}
	GetPrivateProfileString("Setting","Language","jp",str,256,m_ini);
	
	if( strcmp(str,"en") != 0 ){
		gLanguage = JAPANESE;
	}else{
		gLanguage = ENGLISH;
	}

	m_WMIStatus = 0;
	SysInfo->GetData(SI_STATUS,(DWORD*)&m_SysInfoStatus);
	DWORD data;
	SysInfo->GetData(PCI_UNKNOWN,&data);
	m_PCIUnknown.Format("%d",data);

	m_hThread = NULL;
	m_EnableAlpha = FALSE;
	m_SelectedTab = 0;

	m_SystemDlg = NULL;
	m_CPUDlg = NULL;
	m_FeatureDlg = NULL;
	m_PCIDlg = NULL;
	m_DeviceDlg = NULL;
	m_DiskDlg = NULL;
	m_DllDlg = NULL;
	m_InfoDlg = NULL;
	m_BgDlg = NULL;
	m_ExpertDlg = NULL;
	m_SystemDlg = new CSystemDlg(this);
	m_CPUDlg = new CCPUDlg(this);
	m_FeatureDlg = new CFeatureDlg(this);
	m_DeviceDlg = new CDeviceDlg(this);
	m_PCIDlg = new CPCIDlg(this);
	m_DiskDlg = new CDiskDlg(this);
	m_DllDlg = new CDllDlg(this);
	m_InfoDlg = new CInfoDlg(this);
	m_BgDlg = new CBgDlg(this);
	m_ExpertDlg = new CExpertDlg(this);

// CRankingDlg ͑̌ʂ𗘗p // 
#ifndef CRYSTAL_SYS_INFO
	m_MarkDlg = NULL;
	m_RankingDlg = NULL;
	m_MarkDlg = new CMarkDlg(this);
	m_RankingDlg = new CRankingDlg(this);
#endif

#ifdef CRYSTAL_SYS_INFO
	m_Dlg[0] = m_SystemDlg;
	m_Dlg[1] = m_CPUDlg;
	m_Dlg[2] = m_FeatureDlg;
	m_Dlg[3] = m_DeviceDlg;
	m_Dlg[4] = m_PCIDlg;
	m_Dlg[5] = m_DiskDlg;
	m_Dlg[6] = m_DllDlg;
	m_Dlg[7] = m_InfoDlg;
	m_Dlg[8] = m_BgDlg;
	m_Dlg[9] = m_ExpertDlg;
#else if
	m_Dlg[0] = m_MarkDlg;
	m_Dlg[1] = m_RankingDlg;
	m_Dlg[2] = m_SystemDlg;
	m_Dlg[3] = m_CPUDlg;
	m_Dlg[4] = m_FeatureDlg;
	m_Dlg[5] = m_DeviceDlg;
	m_Dlg[6] = m_PCIDlg;
	m_Dlg[7] = m_DiskDlg;
	m_Dlg[8] = m_DllDlg;
	m_Dlg[9] = m_InfoDlg;
	m_Dlg[10] = m_BgDlg;
	m_Dlg[11] = m_ExpertDlg;
#endif

#ifdef CRYSTAL_SYS_INFO
//	m_Tab.InsertItem(0,"Mark");		AddPage(m_MarkDlg,IDD_MARK_DIALOG);
//	m_Tab.InsertItem(1,"Ranking");	AddPage(m_RankingDlg,IDD_RANKING_DIALOG);
	m_Tab.InsertItem(0,"System");	AddPage(m_SystemDlg,IDD_SYSTEM_DIALOG);
	m_Tab.InsertItem(1,"CPU");		AddPage(m_CPUDlg,IDD_CPU_DIALOG);
	m_Tab.InsertItem(2,"Feature");	AddPage(m_FeatureDlg,IDD_FEATURE_DIALOG);
	m_Tab.InsertItem(3,"Device");	AddPage(m_DeviceDlg,IDD_DEVICE_DIALOG);
 	m_Tab.InsertItem(4,"PCI");		AddPage(m_PCIDlg,IDD_PCI_DIALOG);
	m_Tab.InsertItem(5,"Disk");		AddPage(m_DiskDlg,IDD_DISK_DIALOG);
	m_Tab.InsertItem(6,"DLL");		AddPage(m_DllDlg,IDD_DLL_DIALOG);
	m_Tab.InsertItem(7,"Info");		AddPage(m_InfoDlg,IDD_INFO_DIALOG);
	m_Tab.InsertItem(8,"Back");		AddPage(m_BgDlg,IDD_BG_DIALOG);
	m_Tab.InsertItem(9,"Expert");	AddPage(m_BgDlg,IDD_EXPERT_DIALOG);
#else if
	m_Tab.InsertItem(2,"System");	AddPage(m_SystemDlg,IDD_SYSTEM_DIALOG);
	m_Tab.InsertItem(3,"CPU");		AddPage(m_CPUDlg,IDD_CPU_DIALOG);
	m_Tab.InsertItem(4,"Feature");	AddPage(m_FeatureDlg,IDD_FEATURE_DIALOG);
	m_Tab.InsertItem(5,"Device");	AddPage(m_DeviceDlg,IDD_DEVICE_DIALOG);
 	m_Tab.InsertItem(6,"PCI");		AddPage(m_PCIDlg,IDD_PCI_DIALOG);
	m_Tab.InsertItem(7,"Disk");		AddPage(m_DiskDlg,IDD_DISK_DIALOG);
	m_Tab.InsertItem(8,"DLL");		AddPage(m_DllDlg,IDD_DLL_DIALOG);
	m_Tab.InsertItem(9,"Info");		AddPage(m_InfoDlg,IDD_INFO_DIALOG);
	m_Tab.InsertItem(10,"Back");	AddPage(m_BgDlg,IDD_BG_DIALOG);
	m_Tab.InsertItem(11,"Expert");	AddPage(m_ExpertDlg,IDD_EXPERT_DIALOG);
	m_Tab.InsertItem(0,"Mark");		AddPage(m_MarkDlg,IDD_MARK_DIALOG);
	m_Tab.InsertItem(1,"Ranking");	AddPage(m_RankingDlg,IDD_RANKING_DIALOG);
#endif

#ifdef CRYSTAL_SYS_INFO
	{
	CString cstr;
	SysInfo->GetString(SI_VERSION,str);
	cstr.Format("%s.%s",CRYSTAL_MARK_VERSION_08,str);
	CrystalMarkVersion.Format("CrystalSysInfo %s",cstr);
	SetWindowText(CrystalMarkVersion);
	// j[j
	CMenu *menu = GetMenu();
	menu->RemoveMenu( 2 , MF_BYPOSITION);
	menu->ModifyMenu( IDM_HELP_TEXT , MF_STRING , IDM_HELP_TEXT , "CrystalSysInfo.txt" );
	menu->ModifyMenu( IDM_MARK_INI , MF_STRING , IDM_MARK_INI , "CrystalSysInfo.ini" );
	}
#else if
	{
	CString cstr;
	SysInfo->GetString(SI_VERSION,str);
	cstr.Format("%s.%s",CRYSTAL_MARK_VERSION_08,str);
	CrystalMarkVersion.Format("CrystalMark %s",cstr);
	SetWindowText(CrystalMarkVersion);
	}
#endif
/////////////////
// j[g
/////////////////

	CMenu *menu = GetMenu();
	CMenu *sub  = menu->GetSubMenu(1);
	
	int i;
	WIN32_FIND_DATA wfd = {0};
	HANDLE hFind = NULL;
	char DirName[MAX_PATH];
	char FindText[MAX_PATH];
	char FindHtml[MAX_PATH];

	::GetModuleFileName(NULL, DirName, MAX_PATH);
	if ( (ptrEnd = strrchr(DirName, '\\')) != NULL ){
		*ptrEnd = '\0';
		strcpy(FindText,DirName);
		strcpy(FindHtml,DirName);
		strcat(FindText, "\\template\\text\\*.txt");
		strcat(FindHtml, "\\template\\html\\*.html");
	}

	for(i=0;i<6;i++)
	{
		int j=0;
		char *Find;

		CMenu *ssub = sub->GetSubMenu(i);
		if(ssub == NULL){continue;}
		// ݒ胁j[ //
		ssub->RemoveMenu(0,MF_BYPOSITION);

		// Text or Html
		if( i < 3){Find = FindText;}
		else{Find = FindHtml;}

		hFind = FindFirstFile(Find, &wfd);
		do {
			if(wfd.nFileSizeLow != 0){ // TCY 0 ̃t@C͖
				ssub->InsertMenu( 0,MF_BYPOSITION,IDM_EDIT_MENU_START + i * 100 + j,wfd.cFileName);
			}
			j++;
		} while (FindNextFile(hFind, &wfd));
		FindClose(hFind);	
	}

	DrawMenuBar();

/////////////////

	m_BackBitmap = NULL;
	m_BackBrush = NULL;

	GetPrivateProfileString("Setting","BackgroundImage","",str,256,m_ini);
	CreateWallPaper(1,NULL,str,0);

	GetPrivateProfileString("Setting","TextColor","",str,256,m_ini);
	if( strcmp(str,"") == 0){
		gTextColor = ::GetSysColor(COLOR_WINDOWTEXT);
	}else{
		gTextColor = atoi(str);
	}
	// Layered Window
	GetPrivateProfileString("Setting","EnableAlpha","0",str,256,m_ini);
	if(atoi(str) > 0){
		GetPrivateProfileString("Setting","Alpha","255",str,256,m_ini);
		SetAlphaWindow(m_hWnd,atoi(str));
		m_EnableAlpha = TRUE;
	}

	if(gLanguage == ENGLISH){
		OnEnglish();
	}else{
		OnJapanese();
	}
//	WMIInit((void*)this);
//	m_hThread = (unsigned long *)_beginthread(WMIInit,0,(void*)this);

	if(! ( CheckSafeMode() & MODE_WMI_OFF ) ){
		AfxBeginThread(WMIInit,(void*)this,THREAD_PRIORITY_NORMAL);
	}

	SelectTab(0);

	DebugInfo(CRYSTAL_MARK_INIT_END);

	DisconnectSysInfo();

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CCrystalMarkDlg::SetWindowTitle(CString mes)
{
	CString cstr;
	cstr.Format("%s %s",CrystalMarkVersion,mes);
	SetWindowText(cstr);
}

void CCrystalMarkDlg::AddPage(CDialog* pDlg,UINT id)
{
	CRect cr;
	m_Tab.GetClientRect(cr);
	int width = cr.Width();
	int height = cr.Height();
	m_Tab.AdjustRect(FALSE,cr);
	cr.top+=1;
	int x=cr.left,y=cr.top;
	pDlg->Create( id , &m_Tab);
//	pDlg->SetWindowPos(&wndTop,x,y,width,height,SWP_HIDEWINDOW);
	pDlg->SetWindowPos(&wndTop,x,y,0,0,SWP_NOSIZE | SWP_HIDEWINDOW);
}

void CCrystalMarkDlg::OnPaint() 
{
	CDialog::OnPaint();
}

HCURSOR CCrystalMarkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCrystalMarkDlg::OnCancel() {CDialog::OnCancel();}
void CCrystalMarkDlg::OnExit() {OnCancel();}
void CCrystalMarkDlg::OnOK() {}

void CCrystalMarkDlg::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	SelectTab(m_Tab.GetCurSel());
	*pResult = 0;
}

void CCrystalMarkDlg::SelectTab(int i)
{
	if(m_WMIStatus == 1)
	{
		m_WMIStatus++;
		m_SystemDlg->UpdateData(FALSE);
		m_DeviceDlg->UpdateData(FALSE);
		m_DiskDlg->SetDiskDetailInfo(0);
		m_DiskDlg->UpdateData(FALSE);
	}

	// ^uIꍇ
//	if(m_SelectedTab == i){return ;}

	CMenu *menu = GetMenu();
#ifdef CRYSTAL_SYS_INFO
	menu->CheckMenuItem(IDM_MARK + 2 + m_SelectedTab,MF_UNCHECKED);
	menu->CheckMenuItem(IDM_MARK + 2 + i,MF_CHECKED);
	menu->EnableMenuItem(IDM_MARK + 2 + m_SelectedTab,MF_ENABLED);
	menu->EnableMenuItem(IDM_MARK + 2 + i,MF_GRAYED);
#else if
	// DLL Check
	menu->CheckMenuItem(IDM_MARK + m_SelectedTab,MF_UNCHECKED);
	menu->CheckMenuItem(IDM_MARK + i,MF_CHECKED);
	menu->EnableMenuItem(IDM_MARK + m_SelectedTab,MF_ENABLED);
	menu->EnableMenuItem(IDM_MARK + i,MF_GRAYED);
#endif
	m_Dlg[m_SelectedTab]->ShowWindow(SW_HIDE);
	m_Dlg[i]->ShowWindow(SW_SHOW);
	m_Tab.SetCurSel(i);
	m_SelectedTab = i;
}

#ifdef CRYSTAL_SYS_INFO

void CCrystalMarkDlg::OnMark(){SelectTab(0);}
void CCrystalMarkDlg::OnRanking(){SelectTab(0);}
void CCrystalMarkDlg::OnSystem(){SelectTab(0);}
void CCrystalMarkDlg::OnCpu(){SelectTab(1);}
void CCrystalMarkDlg::OnFeature(){SelectTab(2);}
void CCrystalMarkDlg::OnDevice(){SelectTab(3);}
void CCrystalMarkDlg::OnPci(){SelectTab(4);}
void CCrystalMarkDlg::OnDisk(){SelectTab(5);}
void CCrystalMarkDlg::OnDll(){SelectTab(6);}
void CCrystalMarkDlg::OnInfo(){SelectTab(7);}
void CCrystalMarkDlg::OnBg(){SelectTab(8);}
void CCrystalMarkDlg::OnExpert(){SelectTab(9);}

#else if

void CCrystalMarkDlg::OnMark(){SelectTab(0);}
void CCrystalMarkDlg::OnRanking(){SelectTab(1);}
void CCrystalMarkDlg::OnSystem(){SelectTab(2);}
void CCrystalMarkDlg::OnCpu(){SelectTab(3);}
void CCrystalMarkDlg::OnFeature(){SelectTab(4);}
void CCrystalMarkDlg::OnDevice(){SelectTab(5);}
void CCrystalMarkDlg::OnPci(){SelectTab(6);}
void CCrystalMarkDlg::OnDisk(){SelectTab(7);}
void CCrystalMarkDlg::OnDll(){SelectTab(8);}
void CCrystalMarkDlg::OnInfo(){SelectTab(9);}
void CCrystalMarkDlg::OnBg(){SelectTab(10);}
void CCrystalMarkDlg::OnExpert(){SelectTab(11);}

#endif

void CCrystalMarkDlg::OnCrystalDewWorld() 
{
	ShellExecute(NULL,NULL,URL_CRYSTAL_MARK_08,NULL,NULL,SW_SHOWNORMAL);	
}

void CCrystalMarkDlg::OnEnglish() 
{
	gLanguage = ENGLISH;
	CMenu *menu = GetMenu();
#ifdef CRYSTAL_SYS_INFO
	menu->ModifyMenu( 0 , MF_BYPOSITION | MF_STRING , 0 , "File (&F)" );
	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "Edit (&E)" );
	menu->ModifyMenu( 2 , MF_BYPOSITION | MF_STRING , 2 , "Help (&H)" );
//	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "Language" );
#else if
	menu->ModifyMenu( 0 , MF_BYPOSITION | MF_STRING , 0 , "File (&F)" );
	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "Edit (&E)" );
	menu->ModifyMenu( 2 , MF_BYPOSITION | MF_STRING , 2 , "Tab (&T)" );
	menu->ModifyMenu( 3 , MF_BYPOSITION | MF_STRING , 3 , "Help (&H)" );
//	menu->ModifyMenu( 4 , MF_BYPOSITION | MF_STRING , 4 , "Language" );
#endif
	menu->ModifyMenu( IDM_EXIT , MF_STRING , IDM_EXIT , "Exit (&E)" );
	menu->ModifyMenu( IDM_HELP_HTML , MF_STRING , IDM_HELP_HTML , "HTML help" );

	menu->CheckMenuItem(IDM_JAPANESE,MF_UNCHECKED);
	menu->CheckMenuItem(IDM_ENGLISH,MF_CHECKED);
	menu->EnableMenuItem(IDM_JAPANESE,MF_ENABLED);
	menu->EnableMenuItem(IDM_ENGLISH,MF_GRAYED);
	
	char ini[MAX_PATH];char* ptrEnd;
	::GetModuleFileName(NULL, ini, MAX_PATH);
	if ( (ptrEnd = strrchr(ini, '.')) != NULL ){*ptrEnd = '\0';strcat(ini, ".ini");}
	WritePrivateProfileString("Setting","Language","en",ini);

#ifndef CRYSTAL_SYS_INFO
	m_InfoDlg->Internationalise();
	m_MarkDlg->Internationalise();
	m_RankingDlg->Internationalise();
//	m_MarkDlg->m_MarkOptionDlg->Internationalise();
#endif
	m_DiskDlg->Internationalise();
	SetMenu(menu);
	if(m_EnableAlpha){
		Invalidate(TRUE);
		UpdateWindow();
	}
}

void CCrystalMarkDlg::OnJapanese() 
{
	gLanguage = JAPANESE;
	CMenu *menu = GetMenu();
#ifdef CRYSTAL_SYS_INFO
	menu->ModifyMenu( 0 , MF_BYPOSITION | MF_STRING , 0 , "t@C (&F)" );
	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "ҏW (&E)" );
	menu->ModifyMenu( 2 , MF_BYPOSITION | MF_STRING , 2 , "wv (&H)" );
//	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "" );
#else if
	menu->ModifyMenu( 0 , MF_BYPOSITION | MF_STRING , 0 , "t@C (&F)" );
	menu->ModifyMenu( 1 , MF_BYPOSITION | MF_STRING , 1 , "ҏW (&E)" );
	menu->ModifyMenu( 2 , MF_BYPOSITION | MF_STRING , 2 , "^u (&T)" );
	menu->ModifyMenu( 3 , MF_BYPOSITION | MF_STRING , 3 , "wv (&H)" );
//	menu->ModifyMenu( 4 , MF_BYPOSITION | MF_STRING , 4 , "" );
#endif
	menu->ModifyMenu( IDM_EXIT , MF_STRING , IDM_EXIT , "I (&E)" );
	menu->ModifyMenu( IDM_HELP_HTML , MF_STRING , IDM_HELP_HTML , "HTML wv" );

	menu->CheckMenuItem(IDM_ENGLISH,MF_UNCHECKED);
	menu->CheckMenuItem(IDM_JAPANESE,MF_CHECKED);
	menu->EnableMenuItem(IDM_ENGLISH,MF_ENABLED);
	menu->EnableMenuItem(IDM_JAPANESE,MF_GRAYED);

	char ini[MAX_PATH];char* ptrEnd;
	::GetModuleFileName(NULL, ini, MAX_PATH);
	if ( (ptrEnd = strrchr(ini, '.')) != NULL ){*ptrEnd = '\0';strcat(ini, ".ini");}
	WritePrivateProfileString("Setting","Language","jp",ini);
	
#ifndef CRYSTAL_SYS_INFO
	m_InfoDlg->Internationalise();
	m_MarkDlg->Internationalise();
	m_RankingDlg->Internationalise();
//	m_MarkDlg->m_MarkOptionDlg->Internationalise();
#endif
	m_DiskDlg->Internationalise();
	SetMenu(menu);
	if(m_EnableAlpha){
		Invalidate(TRUE);
		UpdateWindow();
	}
}

#ifndef CRYSTAL_SYS_INFO
void CCrystalMarkDlg::OnHelpText(){ExecuteFile("CrystalMark08.txt");}
void CCrystalMarkDlg::OnMarkIni(){ExecuteFile("CrystalMark08.ini");}
#else
void CCrystalMarkDlg::OnHelpText(){ExecuteFile("CrystalSysInfo.txt");}
void CCrystalMarkDlg::OnMarkIni(){ExecuteFile("CrystalSysInfo.ini");}
#endif
void CCrystalMarkDlg::OnSysInfoText(){ExecuteFile("SysInfo.txt");}
void CCrystalMarkDlg::OnHelpHtml(){ExecuteFile("CrystalMark08.chm");}
void CCrystalMarkDlg::OnCpuSupport(){ExecuteFile("CPUSupport.html");}
//void CCrystalMarkDlg::OnCoreSystemText() {ExecuteFile("CrystalMarkCS.txt");}

CString TrimSpace(CString& source);

CString TrimSpace(CString& source)
{
	CString cstr;
	cstr = source;
	cstr.TrimLeft();
	return cstr;
}

void AddString(CString& text,CString& html,char* add,CString& value);

void AddString(CString& text,CString& html,char* key,CString& value)
{
	CString t,h;
	t.Format("%s : %s\r\n",key,value);
	h.Format("<tr><td align=\"right\">%s</td><td>%s</td></tr>\r\n",key,value);

	text += t;
	html += h;
}

// file : t@C
// type : 1=HTML,0=TEXT
// flag : 9=o^ 3=ϐɕۑ 2=vr[ 1=t@Cɕۑ 0=Nbv{[hɃRs[
void CCrystalMarkDlg::Copy(char* file,int type,int flag,CString* result)
{
//	UpdateData(TRUE);
//	MessageBox("","",MB_OK);
	CString clip;
	CString cstr;
	CString text;
	CString html;
//	char str[256];
	DWORD i=0;

	char buf[1024];char fullpath[MAX_PATH];char path[MAX_PATH];char* pEnd;
	::GetModuleFileName(NULL,path,MAX_PATH);
	if ( (pEnd = strrchr(path, '\\')) != NULL ){*pEnd = '\0';}
	if(type == 1){
		sprintf(fullpath,"%s\\template\\html\\%s",path,file);
	}else{
		sprintf(fullpath,"%s\\template\\text\\%s",path,file);
	}
//	MessageBox(fullpath);
	FILE *fp;
	fp = fopen(fullpath,"rb");
	if(fp != NULL){
		while( fgets(buf,1024,fp) ){clip += buf;}
		fclose(fp);
	}else{
		return ;
	}

// Debug 
	clip.Replace("%Debug%",m_CPUDlg->m_MSRInfo);

	clip.Replace("%DisplayMode%",m_DeviceDlg->m_DeviceDisplayMode);
// Device
	clip.Replace("%ChipSet%",TrimSpace(m_DeviceDlg->m_DeviceChipSet));
	clip.Replace("%North%",TrimSpace(m_DeviceDlg->m_DeviceNorth));
	clip.Replace("%South%",TrimSpace(m_DeviceDlg->m_DeviceSouth));
	clip.Replace("%IDEController%",TrimSpace(m_DeviceDlg->m_DeviceIDE));
// Graphics
	clip.Replace("%DirectX%",TrimSpace(m_DeviceDlg->m_DeviceDirectXVersion));
	clip.Replace("%Video%",TrimSpace(m_DeviceDlg->m_DeviceVideo));
	clip.Replace("%VideoProduct%",TrimSpace(m_DeviceDlg->m_DeviceVideoCaption));
	clip.Replace("%VideoVendor%",TrimSpace(m_DeviceDlg->m_DeviceVideoVendor));
	clip.Replace("%VideoChip%",TrimSpace(m_DeviceDlg->m_DeviceVideoChip));

	if( m_DeviceDlg->m_DeviceVideoRAM.IsEmpty() ){
		clip.Replace("%VideoRAM%","");
	}else{
		cstr = TrimSpace(m_DeviceDlg->m_DeviceVideoRAM) + " MB";
		clip.Replace("%VideoRAM%",cstr);
	}
	clip.Replace("%VideoDriverVersion%",TrimSpace(m_DeviceDlg->m_DeviceVideoDriverVersion));
	clip.Replace("%VideoDriverDate%",TrimSpace(m_DeviceDlg->m_DeviceVideoDriverDate));

// PCI Device List
	text = "No Bus Dev Fnc VendorDeviceRev SubSystem  Class  DeviceType\r\n";
	html = "<table width=\"100%\" border=\"1\" cellspacing=\"0\" cellpadding=\"3\">";
	html += "<tr><td>No</td><td>Bus</td><td>Dev</td><td>Fnc</td><td>Vendor</td><td>Device</td><td>Rev</td><td>SubSystem</td><td>Class</td><td>DeviceType</td></tr>";
	for(i=0;i<m_PCIDlg->m_NumberOfItem;i++){
		html += "<tr>";
		cstr.Format("%2d ",i);text += cstr;html += "<td>" + cstr + "</td>";		
		cstr.Format("%3s",m_PCIDlg->m_PciList.GetItemText(i,1));text += cstr + ":";html += "<td>" + cstr + "</td>";
		cstr.Format("%3s",m_PCIDlg->m_PciList.GetItemText(i,2));text += cstr + ":";html += "<td>" + cstr + "</td>";
		cstr.Format("%3s ",m_PCIDlg->m_PciList.GetItemText(i,3));text += cstr;html += "<td>" + cstr + "</td>";
		cstr = m_PCIDlg->m_PciList.GetItemText(i,4);text += cstr + ":";html += "<td>" + cstr + "</td>";
		cstr = m_PCIDlg->m_PciList.GetItemText(i,5);text += cstr + ".";html += "<td>" + cstr + "</td>";
		cstr = m_PCIDlg->m_PciList.GetItemText(i,6);text += cstr + " ";html += "<td>" + cstr + "</td>";

		cstr = m_PCIDlg->m_PciList.GetItemText(i,7);text += cstr + " ";html += "<td>" + cstr + "</td>";
		cstr = m_PCIDlg->m_PciList.GetItemText(i,8);text += cstr + " ";html += "<td>" + cstr + "</td>";
		cstr = m_PCIDlg->m_PciList.GetItemText(i,9);text += cstr + "";html += "<td>" + cstr + "</td>";
		text += "\r\n";html += "</tr>\r\n";
	}
	text += "\r\n";
	html += "</table>\r\n";

	text += "No DeviceName | SubSystem Vendor\r\n";
	html += "<table width=\"100%\" border=\"1\" cellspacing=\"0\">";
	html += "<tr><td>No</td><td>DeviceName</td><td>SubSystem Vendor</td></tr>";
	for(i=0;i<m_PCIDlg->m_NumberOfItem;i++){
		html += "<tr>";
		cstr.Format("%2d ",i);text += cstr;html += "<td>" + cstr + "</td>";
		cstr = m_PCIDlg->m_PciList.GetItemText(i,10);text += cstr + " ";html += "<td>" + cstr + " ";		
		cstr = m_PCIDlg->m_PciList.GetItemText(i,11);text += cstr + "";html += cstr + "</td>";		
		cstr = m_PCIDlg->m_PciList.GetItemText(i,12);html += "<td>" + cstr + "</td>";		
		if(! cstr.IsEmpty()){
			text += " | ";
			text += cstr;
			//text += "]";
		}
		text += "\r\n";html += "</tr>\r\n";
	}
	text.TrimRight("\r\n");
	html += "</table>\r\n";
	if(type == 1){
		clip.Replace("%PciList%",html);
	}else{
		clip.Replace("%PciList%",text);
	}
// HDD List
	int data;

	text = "Type Size    Model                                  ( Buffer Mode )     \r\n";
	html = "<table width=\"100%\" border=\"1\" cellspacing=\"0\" cellpadding=\"3\">";
	html += "<tr><td>Type</td><td>Size</td><td>Model</td><td>Buffer</td><td>Mode</td></tr>";
	for(i=0;i<m_DiskDlg->m_NumberOfItem;i++){
		html += "<tr>";
	//	cstr.Format("%2d ",i);text += cstr;	
		cstr.Format("%-4s ",m_DiskDlg->m_DiskList.GetItemText(i,1));text += cstr;html += "<td>" + cstr + "</td>";
		cstr.Format("%5.1fGB ",atof(m_DiskDlg->m_DiskList.GetItemText(i,2)));text += cstr;html += "<td>" + cstr + "</td>";
		cstr.Format("%-40s ",m_DiskDlg->m_DiskList.GetItemText(i,0));text += cstr;html += "<td>" + cstr + "</td>";
		if( ( data = atoi(m_DiskDlg->m_DiskList.GetItemText(i,3)) ) > 0 ){
			cstr.Format("%4dKB ",data);
			text += cstr;html += "<td>" + cstr + "</td>";
			if( m_DiskDlg->m_DiskList.GetItemText(i,10) != "" ){
				cstr.Format("%-16s ",m_DiskDlg->m_DiskList.GetItemText(i,10));
			}else{
				cstr = "";
			}
			text += cstr;html += "<td>" + cstr + "</td>";
		}else{
			cstr = "";
			text += cstr;html += "<td>" + cstr + "</td>";
			text += cstr;html += "<td>" + cstr + "</td>";
		}

		//m_DiskCHS = m_DiskDlg->m_DiskList.GetItemText(hotItem,4);
		//m_DiskLBA28 = m_DiskDlg->m_DiskList.GetItemText(hotItem,5);
		//m_DiskLBA48 = m_DiskDlg->m_DiskList.GetItemText(hotItem,6);
		//m_DiskSerialNumber = m_DiskDlg->m_DiskList.GetItemText(hotItem,7);
		//m_DiskRevision = m_DiskDlg->m_DiskList.GetItemText(hotItem,8);
		text += "\r\n";html += "</tr>\r\n";
	}
	text.TrimRight("\r\n");
	html += "</table>\r\n";
	if(type == 1){
		clip.Replace("%HddList%",html);
	}else{
		clip.Replace("%HddList%",text);
	}
	clip.Replace("%VERSION%",CrystalMarkVersion);
///////////////
// SystemDlg //
	CString OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo;
	GetOSInfo(OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo);
	cstr = OSName + " " + OSType + " " + OSCSD + " [" + OSVersion + " Build " + OSBuild + "]";
	clip.Replace("%OS%",cstr);

	if( ! m_RankingDlg->m_MemoryUser.IsEmpty() ){
		cstr.Format("%d MB (%s)", atoi(m_SystemDlg->m_SysMemTotalPhys) + 1, m_RankingDlg->m_MemoryUser );
	}else{
		cstr.Format("%d MB", atoi(m_SystemDlg->m_SysMemTotalPhys) + 1 );
	}
	clip.Replace("%Memory%",cstr);

// BIOS
	clip.Replace("%BIOSVendor%",TrimSpace(m_SystemDlg->m_SysBiosManufacturer));
	clip.Replace("%BIOSCaption%",TrimSpace(m_SystemDlg->m_SysBiosCaption));
	clip.Replace("%BIOSVersion%",TrimSpace(m_SystemDlg->m_SysBiosVersion));
	clip.Replace("%BIOSDate%",TrimSpace(m_SystemDlg->m_SysBiosDate));
// SM BIOS
	clip.Replace("%SMBIOSCaption%",TrimSpace(m_SystemDlg->m_SysBiosSMBiosVersion));
	clip.Replace("%SMBIOSVersion%",TrimSpace(m_SystemDlg->m_SysBiosSMVersion));
// Mother
	clip.Replace("%MotherVendor%",TrimSpace(m_SystemDlg->m_SysMotherManufacturer));
	clip.Replace("%MotherProduct%",TrimSpace(m_SystemDlg->m_SysMotherProduct));
	clip.Replace("%MotherVersion%",TrimSpace(m_SystemDlg->m_SysMotherVersion));
// Computer System
	clip.Replace("%SystemManufacturer%",TrimSpace(m_SystemDlg->m_SysSystemManufacturer));
	clip.Replace("%SystemModel%",TrimSpace(m_SystemDlg->m_SysSystemModel));

////////////
// CPUDlg //
	if(! m_CPUDlg->m_CodeName.IsEmpty() ){
		cstr.Format("%s (%s)",m_CPUDlg->m_CPUName,m_CPUDlg->m_CodeName);
	}else{
		cstr.Format("%s",m_CPUDlg->m_CPUName);
	}
//	AddString(text,html,"",);
	text = "";
	html = "<table width=\"100%\" border=\"1\" cellspacing=\"0\" cellpadding=\"3\">";
	if(! m_CPUDlg->m_CPUName.IsEmpty()){		AddString(text,html,"       CPU Name",cstr);}
	if(! m_CPUDlg->m_VendorString.IsEmpty()){	AddString(text,html,"  Vendor String",m_CPUDlg->m_VendorString);}
	if(! m_CPUDlg->m_NameString.IsEmpty()){		AddString(text,html,"    Name String",m_CPUDlg->m_NameString);}
	if(! m_CPUDlg->m_Platform.IsEmpty()){		AddString(text,html,"       Platform",m_CPUDlg->m_Platform);}
	if(! m_CPUDlg->m_CPUType.IsEmpty()){		AddString(text,html,"       CPU Type",m_CPUDlg->m_CPUType);}
	if(! m_CPUDlg->m_CPUNumber.IsEmpty()){		AddString(text,html,"Number(Logical)",m_CPUDlg->m_CPUNumber);}
	
	if(! m_CPUDlg->m_HyperThreading.IsEmpty()){	AddString(text,html,"Hyper-Threading",m_CPUDlg->m_HyperThreading);}
	if(! m_CPUDlg->m_Family.IsEmpty()){			AddString(text,html,"         Family",m_CPUDlg->m_Family);	}
	if(! m_CPUDlg->m_FamilyEx.IsEmpty()){		AddString(text,html,"       FamilyEx",m_CPUDlg->m_FamilyEx);}
	if(! m_CPUDlg->m_ExFamily.IsEmpty()){		AddString(text,html,"     Generation",m_CPUDlg->m_ExFamily);}
	if(! m_CPUDlg->m_Model.IsEmpty()){			AddString(text,html,"          Model",m_CPUDlg->m_Model);}
	if(! m_CPUDlg->m_Stepping.IsEmpty()){		AddString(text,html,"       Stepping",m_CPUDlg->m_Stepping);}
//	if(! m_CPUDlg->m_ExModel.IsEmpty()){		AddString(text,html,"        ExModel",m_CPUDlg->m_ExModel);
//	if(! m_CPUDlg->m_ExStepping.IsEmpty()){		AddString(text,html,"     ExStepping",m_CPUDlg->m_ExStepping);}
//	if(! m_CPUDlg->m_ModelEx.IsEmpty()){		AddString(text,html,"        ModelEx",m_CPUDlg->m_ModelEx);}
	if(! m_CPUDlg->m_BrandID.IsEmpty()){		AddString(text,html,"        BrandID",m_CPUDlg->m_BrandID);}
	if(! m_CPUDlg->m_Apic.IsEmpty()){			AddString(text,html,"           APIC",m_CPUDlg->m_Apic);}

	text += "        Feature :";
	html += "<tr><td align=\"right\">Feature</td><td>";
	if( m_CPUDlg->m_MMXC.IsWindowEnabled() ){text += " MMX";html += " MMX";}
	if( m_CPUDlg->m_SSEC.IsWindowEnabled() ){text += " SSE";html += " SSE";}
	if( m_CPUDlg->m_SSE2C.IsWindowEnabled() ){text += " SSE2";html += " SSE2";}
	if( m_CPUDlg->m_MMXExC.IsWindowEnabled() ){text += " MMX+";html += " MMX+";}
	if( m_CPUDlg->m_3DNowC.IsWindowEnabled() ){text += " 3DNow!";html += " 3DNow!";}
	if( m_CPUDlg->m_3DNowExC.IsWindowEnabled() ){text += " 3DNow!+";html += " 3DNow!+";}
	if( m_CPUDlg->m_HTC.IsWindowEnabled() ){text += " Hyper-Threading";html += " Hyper-Threading";}
	html += "</td></tr>\r\n";

	text += "\r\n";
	html += "<tr><td colspan=\"2\"><table width=\"100%\" border=\"1\" cellspacing=\"0\" cellpadding=\"3\">";
	if(atof(m_CPUDlg->m_ClockOri) > 0.0){
		text += "\r\n                    Current        Original\r\n";
		html += "<tr><td> </td><td>Current</td><td>Original</td></tr>\r\n";
	}
    
	if(atof(m_CPUDlg->m_Clock) > 0.0){
		cstr.Format("%7.2f",atof(m_CPUDlg->m_Clock));
		text += "          Clock : " + cstr + " MHz";
		html += "<tr><td align=\"right\">Clock</td><td>" + cstr + " MHz</td>";
		if(atof(m_CPUDlg->m_ClockOri) > 0.0){
			cstr.Format("%7.2f",atof(m_CPUDlg->m_ClockOri));
			text += "     " + cstr + " MHz";
			html += "<td>" + cstr + " MHz</td>";
		}
		text += "\r\n";
		html += "</tr>\r\n";
	}
	if(atof(m_CPUDlg->m_SystemClock) > 0.0){
		cstr.Format("%7.2f",atof(m_CPUDlg->m_SystemClock));
		text += "   System Clock : " + cstr + " MHz";
		html += "<tr><td align=\"right\">System Clock</td><td>" + cstr + " MHz</td>";
		if(atof(m_CPUDlg->m_SystemClockOri) > 0.0){
			cstr.Format("%7.2f",atof(m_CPUDlg->m_SystemClockOri));
			text += "     " + cstr + " MHz";
			html += "<td>" + cstr + " MHz</td>";
		}
		text +="\r\n";
		html += "</tr>\r\n";
	}
	if(atof(m_CPUDlg->m_SystemBus) > 0.0){
		cstr.Format("%7.2f",atof(m_CPUDlg->m_SystemBus));
		text += "     System Bus : " + cstr + " MHz";
		html += "<tr><td align=\"right\">System Bus</td><td>" + cstr + " MHz</td>";
		if(atof(m_CPUDlg->m_SystemBusOri) > 0.0){
			cstr.Format("%7.2f",atof(m_CPUDlg->m_SystemBusOri));
			text += "     " + cstr + " MHz";
			html += "<td>" + cstr + " MHz</td>";
		}
		text +="\r\n";
		html += "</tr>\r\n";
	}
	html += "</table></td></tr>";

	if(atof(m_CPUDlg->m_Multiplier) > 0.0){
		cstr.Format("%7.2f",atof(m_CPUDlg->m_Multiplier));
		text += "     Multiplier : " + cstr;
	}
	if(atof(m_CPUDlg->m_MultiplierOri) > 0.0){
		cstr.Format("%7.2f",atof(m_CPUDlg->m_MultiplierOri));
		text += "         " + cstr;
	}
	if(atof(m_CPUDlg->m_Multiplier) > 0.0){
		text +="\r\n";
	}

	if(! m_CPUDlg->m_DataRate.IsEmpty()){
		text += "      Data Rate :    " + m_CPUDlg->m_DataRate + "\r\n";
	}
	
	if(atof(m_CPUDlg->m_ClockOri) > 0.0){
		cstr.Format("%7.2f %%",atof(m_CPUDlg->m_OverClock));
		text += "     Over Clock : " + cstr + "\r\n";
	}

	if(atoi(m_CPUDlg->m_L1ITUCache) > 0){
		cstr.Format("%4d",atoi(m_CPUDlg->m_L1ITUCache));
		text += "\r\n     " + m_CPUDlg->m_CacheL1ITU + " : " + cstr + " " + m_CPUDlg->m_CacheL1ITUUnit + "\r\n"; 
	}
	if(atoi(m_CPUDlg->m_L1DataCache) > 0){
		cstr.Format("%4d",atoi(m_CPUDlg->m_L1DataCache));
		text += "     L1 D-Cache : " + cstr + " KB\r\n";
	}
	if(atoi(m_CPUDlg->m_L2Cache) > 0){
		cstr.Format("%4d",atoi(m_CPUDlg->m_L2Cache));
		text += "       L2 Cache : " + cstr + " KB [" + m_CPUDlg->m_L2CacheSpeed + ":" + m_CPUDlg->m_L2CacheSpeedMHz + " MHz]\r\n";
	}
	if(atoi(m_CPUDlg->m_L3Cache) > 0){
		cstr.Format("%4d",atoi(m_CPUDlg->m_L3Cache));
		text += "       L3 Cache : " + cstr + " KB\r\n";
	}
	text.TrimRight("\r\n");
	html += "</table>";

	if(type == 1){
		clip.Replace("%CPUDetail%",html);
	}else{
		clip.Replace("%CPUDetail%",text);
	}
// CPUID Detail //
	DWORD dwEAX,dwEBX,dwECX,dwEDX;
	text = "";
	GetCPUID(0x0,&dwEAX,&dwEBX,&dwECX,&dwEDX);
	cstr.Format("     0x%08X : EAX=0x%08X EBX=0x%08X ECX=0x%08X EDX=0x%08X\r\n",0,dwEAX,dwEBX,dwECX,dwEDX);
	text += cstr;
	DWORD MaxCPUID = dwEAX;
	for(i=1;i<=MaxCPUID;i++){
		GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
		cstr.Format("     0x%08X : EAX=0x%08X EBX=0x%08X ECX=0x%08X EDX=0x%08X\r\n",i,dwEAX,dwEBX,dwECX,dwEDX);
		text += cstr;
	}

	GetCPUID(0x80000000,&dwEAX,&dwEBX,&dwECX,&dwEDX);
	if(dwEAX > 0x80000000){
		cstr.Format("     0x%08X : EAX=0x%08X EBX=0x%08X ECX=0x%08X EDX=0x%08X\r\n",0x80000000,dwEAX,dwEBX,dwECX,dwEDX);
		text += cstr;
		DWORD MaxCPUIDEx = dwEAX;
		for(i=0x80000001;i<=MaxCPUIDEx;i++){
			GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
			cstr.Format("     0x%08X : EAX=0x%08X EBX=0x%08X ECX=0x%08X EDX=0x%08X\r\n",i,dwEAX,dwEBX,dwECX,dwEDX);
			text += cstr;
		}
	}

	if(m_CPUDlg->m_VendorString.Find("TMx86") != -1){
		GetCPUID(0x80860000,&dwEAX,&dwEBX,&dwECX,&dwEDX);
		cstr.Format("     0x%08X : EAX=0x%08X EBX=0x%08X ECX=0x%08X EDX=0x%08X\r\n",0x80860000,dwEAX,dwEBX,dwECX,dwEDX);
		text += cstr;
		DWORD MaxCPUIDTx = dwEAX;
		for(i=0x80860001;i<=MaxCPUIDTx;i++){
			GetCPUID(i,&dwEAX,&dwEBX,&dwECX,&dwEDX);
			cstr.Format("     0x%08X : EAX=0x%08X EBX=0x%08X ECX=0x%08X EDX=0x%08X\r\n",i,dwEAX,dwEBX,dwECX,dwEDX);
			text += cstr;
		}
	}
	text.TrimRight("\r\n");
	// HTML [h
	if(type == 1){
		text.Replace("\r\n","<br>\r\n");
	}
	clip.Replace("%CPUIDDetail%",text);

	// x`}[N

	text = "";

cstr.Format("\
------------------------------------------------------------------------------\r\n\
CrystalMark Result\r\n\
------------------------------------------------------------------------------\r\n\
");

	m_MarkDlg->UpdateData(TRUE);
	m_RankingDlg->UpdateData(TRUE);

	text += cstr;
	if(! m_MarkDlg->m_MarkOptionDisplayMode.IsEmpty() )
	{
		cstr.Format("   Display Mode : %s (%s)\r\n",
			m_MarkDlg->m_MarkOptionDisplayMode,
			m_MarkDlg->m_MarkOptionFontSmoothing);
		text += cstr;
	}

	// RAID / HDD
	if( m_RankingDlg->m_RaidOn ){
		if( ! m_RankingDlg->m_RaidController.IsEmpty() && ! m_RankingDlg->m_RaidSize.IsEmpty() && ! m_RankingDlg->m_RaidType.IsEmpty()){
			cstr.Format("      Disk Info : %s [ %.1f GB ] [ %s ]\r\n", m_RankingDlg->m_RaidController , m_RankingDlg->m_RaidSize, m_RankingDlg->m_RaidType );
			text += cstr;
		}
	}else{
		if( ! m_RankingDlg->m_DiskNameUser.IsEmpty() && ! m_RankingDlg->m_DiskSizeUser.IsEmpty()){
			cstr.Format("      Disk Info : %s [ %.1f GB ]\r\n", m_RankingDlg->m_DiskNameUser , atof(m_RankingDlg->m_DiskSizeUser) );
			text += cstr;
		}
	}

	text += "\r\n";


cstr.Format("\
    CrystalMark : %7d\r\n\
\r\n\
[ ALU ]           %7d\r\n\
      Fibonacci : %7d\r\n\
      Napierian : %7d\r\n\
   Eratosthenes : %7d\r\n\
      QuickSort : %7d\r\n\
[ FPU ]           %7d\r\n\
        MikoFPU : %7d\r\n\
     RandMeanSS : %7d\r\n\
            FFT : %7d\r\n\
     Mandelbrot : %7d\r\n\
[ MEM ]           %7d\r\n\
           Read : %7.2f MB/s (%6d )\r\n\
          Write : %7.2f MB/s (%6d )\r\n\
     Read/Write : %7.2f MB/s (%6d )\r\n\
          Cache : %7.2f MB/s (%6d )\r\n\
[ HDD ]           %7d\r\n\
           Read : %7.2f MB/s (%6d )\r\n\
          Write : %7.2f MB/s (%6d )\r\n\
 RandomRead512K : %7.2f MB/s (%6d )\r\n\
RandomWrite512K : %7.2f MB/s (%6d )\r\n\
 RandomRead 64K : %7.2f MB/s (%6d )\r\n\
RandomWrite 64K : %7.2f MB/s (%6d )\r\n\
[ GDI ]           %7d\r\n\
           Text : %7d\r\n\
         Square : %7d\r\n\
         Circle : %7d\r\n\
         BitBlt : %7d\r\n\
[ D2D ]           %7d\r\n\
   Sprite    10 : %7.2f FPS  (%6d )\r\n\
   Sprite   100 : %7.2f FPS  (%6d )\r\n\
   Sprite   500 : %7.2f FPS  (%6d )\r\n\
   Sprite  1000 : %7.2f FPS  (%6d )\r\n\
   Sprite  5000 : %7.2f FPS  (%6d )\r\n\
   Sprite 10000 : %7.2f FPS  (%6d )\r\n\
",
m_MarkDlg->R[0][0],
m_MarkDlg->R[0][1],
m_MarkDlg->R[1][0],
m_MarkDlg->R[1][1],
m_MarkDlg->R[1][2],
m_MarkDlg->R[1][3],
m_MarkDlg->R[0][2],
m_MarkDlg->R[2][0],
m_MarkDlg->R[2][1],
m_MarkDlg->R[2][2],
m_MarkDlg->R[2][3],
m_MarkDlg->R[0][3],
m_MarkDlg->V[3][0] / 100.0,m_MarkDlg->R[3][0],
m_MarkDlg->V[3][1] / 100.0,m_MarkDlg->R[3][1],
m_MarkDlg->V[3][2] / 100.0,m_MarkDlg->R[3][2],
m_MarkDlg->V[3][3] / 100.0,m_MarkDlg->R[3][3],
m_MarkDlg->R[0][4],
m_MarkDlg->V[4][0] / 100.0,m_MarkDlg->R[4][0],
m_MarkDlg->V[4][1] / 100.0,m_MarkDlg->R[4][1],
m_MarkDlg->V[4][2] / 100.0,m_MarkDlg->R[4][2],
m_MarkDlg->V[4][3] / 100.0,m_MarkDlg->R[4][3],
m_MarkDlg->V[4][4] / 100.0,m_MarkDlg->R[4][4],
m_MarkDlg->V[4][5] / 100.0,m_MarkDlg->R[4][5],
m_MarkDlg->R[0][6],
m_MarkDlg->R[6][0],
m_MarkDlg->R[6][1],
m_MarkDlg->R[6][2],
m_MarkDlg->R[6][3],
m_MarkDlg->R[0][7],
m_MarkDlg->V[7][0] / 100.0,m_MarkDlg->R[7][0],
m_MarkDlg->V[7][1] / 100.0,m_MarkDlg->R[7][1],
m_MarkDlg->V[7][2] / 100.0,m_MarkDlg->R[7][2],
m_MarkDlg->V[7][3] / 100.0,m_MarkDlg->R[7][3],
m_MarkDlg->V[7][4] / 100.0,m_MarkDlg->R[7][4],
m_MarkDlg->V[7][5] / 100.0,m_MarkDlg->R[7][5]
);

	text += cstr;

#ifdef CRYSTAL_SYS_INFO
	clip.Replace("%CrystalMarkResult%","");
#else if
	clip.Replace("%CrystalMarkResult%",text);
#endif

cstr.Format("\
<table width=\"750\" border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\r\n\
<tr><td bgcolor=\"#bbbbbb\" width=\"250\">CrystalMark</td><td width=\"500\">%7d</td></tr>\r\n\
<tr><td bgcolor=\"#dddddd\">ALU</td><td>%7d</td></tr>\r\n\
<tr><td>Fibonacci</td><td>%7d</td></tr>\r\n\
<tr><td>Napierian</td><td>%7d</td></tr>\r\n\
<tr><td>Eratosthenes</td><td>%7d</td></tr>\r\n\
<tr><td>QuickSort</td><td>%7d</td></tr>\r\n\
<tr><td bgcolor=\"#dddddd\">FPU</td><td>%7d</td></tr>\r\n\
<tr><td>MikoFPU</td><td>%7d</td></tr>\r\n\
<tr><td>RandMeanSS</td><td>%7d</td></tr>\r\n\
<tr><td>FFT</td><td>%7d</td></tr>\r\n\
<tr><td>Mandelbrot</td><td>%7d</td></tr>\r\n\
<tr><td bgcolor=\"#dddddd\">MEM</td><td>%7d</td></tr>\r\n\
<tr><td>Read</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td>Write</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td>Read/Write</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td>Cache</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td bgcolor=\"#dddddd\">HDD</td><td>%7d</td></tr>\r\n\
<tr><td>Read</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td>Write</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td>RandomRead512K</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td>RandomWrite512K</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td>RandomRead 64K</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td>RandomWrite 64K</td><td>%7.2f MB/s (%6d )</td></tr>\r\n\
<tr><td bgcolor=\"#dddddd\">GDI</td><td>%7d</td></tr>\r\n\
<tr><td>Text</td><td>%7d</td></tr>\r\n\
<tr><td>Square</td><td>%7d</td></tr>\r\n\
<tr><td>Circle</td><td>%7d</td></tr>\r\n\
<tr><td>BitBlt</td><td>%7d</td></tr>\r\n\
<tr><td bgcolor=\"#dddddd\">D2D</td><td>%7d</td></tr>\r\n\
<tr><td>Sprite    10</td><td>%7.2f FPS (%6d )</td></tr>\r\n\
<tr><td>Sprite   100</td><td>%7.2f FPS (%6d )</td></tr>\r\n\
<tr><td>Sprite   500</td><td>%7.2f FPS (%6d )</td></tr>\r\n\
<tr><td>Sprite  1000</td><td>%7.2f FPS (%6d )</td></tr>\r\n\
<tr><td>Sprite  5000</td><td>%7.2f FPS (%6d )</td></tr>\r\n\
<tr><td>Sprite 10000</td><td>%7.2f FPS (%6d )</td></tr>\r\n\
</table>\r\n\
",
m_MarkDlg->R[0][0],
m_MarkDlg->R[0][1],
m_MarkDlg->R[1][0],
m_MarkDlg->R[1][1],
m_MarkDlg->R[1][2],
m_MarkDlg->R[1][3],
m_MarkDlg->R[0][2],
m_MarkDlg->R[2][0],
m_MarkDlg->R[2][1],
m_MarkDlg->R[2][2],
m_MarkDlg->R[2][3],
m_MarkDlg->R[0][3],
m_MarkDlg->V[3][0] / 100.0,m_MarkDlg->R[3][0],
m_MarkDlg->V[3][1] / 100.0,m_MarkDlg->R[3][1],
m_MarkDlg->V[3][2] / 100.0,m_MarkDlg->R[3][2],
m_MarkDlg->V[3][3] / 100.0,m_MarkDlg->R[3][3],
m_MarkDlg->R[0][4],
m_MarkDlg->V[4][0] / 100.0,m_MarkDlg->R[4][0],
m_MarkDlg->V[4][1] / 100.0,m_MarkDlg->R[4][1],
m_MarkDlg->V[4][2] / 100.0,m_MarkDlg->R[4][2],
m_MarkDlg->V[4][3] / 100.0,m_MarkDlg->R[4][3],
m_MarkDlg->V[4][4] / 100.0,m_MarkDlg->R[4][4],
m_MarkDlg->V[4][5] / 100.0,m_MarkDlg->R[4][5],
m_MarkDlg->R[0][6],
m_MarkDlg->R[6][0],
m_MarkDlg->R[6][1],
m_MarkDlg->R[6][2],
m_MarkDlg->R[6][3],
m_MarkDlg->R[0][7],
m_MarkDlg->V[7][0] / 100.0,m_MarkDlg->R[7][0],
m_MarkDlg->V[7][1] / 100.0,m_MarkDlg->R[7][1],
m_MarkDlg->V[7][2] / 100.0,m_MarkDlg->R[7][2],
m_MarkDlg->V[7][3] / 100.0,m_MarkDlg->R[7][3],
m_MarkDlg->V[7][4] / 100.0,m_MarkDlg->R[7][4],
m_MarkDlg->V[7][5] / 100.0,m_MarkDlg->R[7][5]
);

text = cstr;

	clip.Replace("%CrystalMarkResultHtml%",text);

	// o^ //
	if(flag == 9){
		clip.Replace("&","%26");
		clip.Replace("+","%2B");
		clip.Replace("=","%3D");
		CString post;

		post = "version=" + CrystalMarkVersion + "&";
		post += "unknown=" + m_PCIUnknown + "&";

		post.Replace("CrystalMark 0.7.","");
		post.Replace("CrystalMark 0.8.","");
		post.Replace(" Alpha","");
		post.Replace(" Beta","");
		post.Replace(".","");
		
		post += "data=" + clip;
		HttpPostMethod((LPSTR)(LPCTSTR)post,SERVER_NAME,SCRIPT_PATH,USER_AGENT);
	}else if(flag == 3){// ϐɕۑ //
		if(result != NULL){
			*result = clip;
		}
	}else if(flag == 2){// Preview //
		CString fullpath = path;
		if(type == 1){fullpath += "\\temp.html";}
		else{fullpath += "\\temp.txt";}
		CStdioFile write(fullpath,CFile::modeCreate|CFile::modeWrite|CFile::typeBinary);
		write.WriteString(clip);
		ShellExecute(m_hWnd,NULL,fullpath,NULL,NULL,SW_SHOWNORMAL);
	}else if(flag == 1){
		CString cstr1,cstr2,cstr3;
		if(type == 1){
			cstr1 = "html";
			cstr2 = "";
			cstr3 = "html (*.html)|*.html|All files (*.*)|(*.*)|";
		}else{
			cstr1 = "txt";
			cstr2 = "";
			cstr3 = "text (*.txt)|*.txt|All files (*.*)|(*.*)|";
		}
		CFileDialog save(FALSE,cstr1,cstr2,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,cstr3);
		if( save.DoModal() == IDOK )
		{
			CStdioFile write(save.GetPathName(),CFile::modeCreate|CFile::modeWrite|CFile::typeBinary);
			write.WriteString(clip);
		}
	}else{
		if(OpenClipboard())
		{
			HGLOBAL clipbuffer;
			char * buffer;
			EmptyClipboard();
			clipbuffer = GlobalAlloc(GMEM_DDESHARE, clip.GetLength()+1);
			buffer = (char*)GlobalLock(clipbuffer);
			strcpy(buffer, LPCSTR(clip));
			GlobalUnlock(clipbuffer);
			SetClipboardData(CF_TEXT,clipbuffer);
			CloseClipboard();
		}
	}
}


BOOL CCrystalMarkDlg::CreateWallPaper(DWORD Mode,char* FileName,char* ResourceName,COLORREF Color)
{
	gFlagBack = FALSE;
	gBackBitmap.Detach();
	gBackBitmap.DeleteObject();
	gBackBrush.DeleteObject();
	Dib.Destroy();

	switch(Mode)
	{
	case 1:
		if( strcmp(ResourceName,"") == 0 ){
			return FALSE;
		}
		if(	gBackBitmap.LoadBitmap(ResourceName) ){
			gBackBrush.CreatePatternBrush(&gBackBitmap);
		}else if( Dib.LoadBmp(ResourceName) ){
			gBackBitmap.Attach((HGDIOBJ)Dib.Handle());
			gBackBrush.CreatePatternBrush(&gBackBitmap);
#ifdef USEPNG
		}else if( Dib.LoadPng(ResourceName) ){
			gBackBitmap.Attach((HGDIOBJ)Dib.Handle());
			gBackBrush.CreatePatternBrush(&gBackBitmap);
#endif
#ifdef USEJPEG
		}else if( Dib.LoadJpeg(ResourceName) ){
			gBackBitmap.Attach((HGDIOBJ)Dib.Handle());
			gBackBrush.CreatePatternBrush(&gBackBitmap);
#endif	
		}else{
			return FALSE;
		}

		m_InfoDlg->m_InfoImageSize.Format("%d x %d", Dib.Width(), Dib.Height()) ;
		m_InfoDlg->UpdateData(FALSE);

		gFlagBack = TRUE;
		return TRUE;
		break;
	case 2:
		gBackBrush.CreateSolidBrush(Color);
		return TRUE;
		break;
	case 0:
	default:
		gFlagBack = FALSE;
		return TRUE;
		break;
	}
	return FALSE;
}

BOOL CCrystalMarkDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if( IDM_EDIT_MENU_START <= wParam && wParam < IDM_EDIT_MENU_END ){
		char FileName[MAX_PATH];
		CMenu *menu = GetMenu();
		menu->GetMenuString(wParam,FileName,MAX_PATH,MF_BYCOMMAND);
		switch( wParam % 1000 / 100)
		{
		case 0:Copy(FileName,0,0);break;
		case 1:Copy(FileName,0,1);break;
		case 2:Copy(FileName,0,2);break;
		case 3:Copy(FileName,1,0);break;
		case 4:Copy(FileName,1,1);break;
		case 5:Copy(FileName,1,2);break;
		default:
			break;
		}
	}

	return CDialog::OnCommand(wParam, lParam);
}

