// CrystalMarkDlg.h : wb_[ t@C
//

#if !defined(AFX_CRYSTALMARKDLG_H__E6C18CB7_3DFF_487F_B2B5_F9D999018D32__INCLUDED_)
#define AFX_CRYSTALMARKDLG_H__E6C18CB7_3DFF_487F_B2B5_F9D999018D32__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../CrystalMarkShare/ISysInfo.h"
#include "MarkDlg.h"
#include "RankingDlg.h"
#include "SystemDlg.h"
#include "CPUDlg.h"
#include "FeatureDlg.h"
#include "DeviceDlg.h"
#include "PCIDlg.h"
#include "DiskDlg.h"
#include "DllDlg.h"
#include "InfoDlg.h"
#include "BgDlg.h"
#include "ExpertDlg.h"

#include "../CrystalMarkShare/DibSection.h"

/////////////////////////////////////////////////////////////////////////////
// CCrystalMarkDlg _CAO

struct FlagDebug
{
	BOOL	CPU;
	BOOL	WMI;
	BOOL	IDE;
	BOOL	PCI;
};

class CCrystalMarkDlg : public CDialog
{
// \z
public:
#ifndef CRYSTAL_SYS_INFO
	CMarkDlg* m_MarkDlg;
	CRankingDlg* m_RankingDlg;
#endif
	CSystemDlg* m_SystemDlg;
	CCPUDlg* m_CPUDlg;
	CFeatureDlg* m_FeatureDlg;
	CPCIDlg* m_PCIDlg;
	CDeviceDlg* m_DeviceDlg;
	CDiskDlg* m_DiskDlg;
	CDllDlg* m_DllDlg;
	CInfoDlg* m_InfoDlg;
	CBgDlg* m_BgDlg;
	CExpertDlg* m_ExpertDlg;

	CCrystalMarkDlg(CWnd* pParent = NULL);	// W̃RXgN^
	~CCrystalMarkDlg();
	CString m_PCIUnknown;
	ISysInfo* SysInfo;
	HINSTANCE hSysInfoLib;
	BOOL ConnectSysInfo(DWORD Mode);
	BOOL DisconnectSysInfo();
	void SetWindowTitle(CString mes);

	FlagDebug FD;
	
	int m_WMIStatus;
	int m_SysInfoStatus;
	BOOL m_EnableAlpha;
	HICON m_hIcon;

	void Copy(char* file,int type,int flag,CString* result = NULL);

	CBitmap *m_BackBitmap;
	CBrush *m_BackBrush;
	
	// DibSection
	CDibSection	Dib;
	CString CrystalMarkVersion;

	char m_ini[MAX_PATH];
	CreateWallPaper(DWORD Mode,char* FileName,char* ResourceName,COLORREF Color);

	// Option
	CComboBox	m_MarkOptionHDDSize;
	CComboBox	m_MarkOptionHDDSelect;
	CComboBox	m_MarkOptionProcessorMask;

// _CAO f[^
	//{{AFX_DATA(CCrystalMarkDlg)
	enum { IDD = IDD_CRYSTALMARK_DIALOG };
	CTabCtrl	m_Tab;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CCrystalMarkDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HANDLE m_hThread;
	int m_SelectedTab;
	CWnd* m_Dlg[16];
	
	void AddPage(CDialog* pDlg,UINT id);
	void SelectTab(int id);

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CCrystalMarkDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCpu();
	afx_msg void OnDevice();
	afx_msg void OnDisk();
	afx_msg void OnFeature();
	afx_msg void OnPci();
	afx_msg void OnSystem();
	afx_msg void OnInfo();
	afx_msg void OnCrystalDewWorld();
	afx_msg void OnMark();
	afx_msg void OnRanking();
	afx_msg void OnHelpHtml();
	afx_msg void OnHelpText();
	afx_msg void OnExit();
	afx_msg void OnEnglish();
	afx_msg void OnJapanese();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnCpuSupport();
	afx_msg void OnMarkIni();
	afx_msg void OnCrystalMarkIni();
	afx_msg void OnSysInfo();
	afx_msg void OnReadMe();
	afx_msg void OnSysInfoText();
	afx_msg void OnDll();
	afx_msg void OnCopyText();
	afx_msg void OnCopyHtml();
	afx_msg void OnBg();
	afx_msg void OnExpert();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_CRYSTALMARKDLG_H__E6C18CB7_3DFF_487F_B2B5_F9D999018D32__INCLUDED_)
