// InfoDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "InfoDlg.h"
#include "../CrystalMarkShare/ItemID.h"
#include "../CrystalMarkShare/Share.h"
#include "../CrystalMarkDll/CrystalMarkDll.h"

#pragma comment(lib, "CrystalMark08.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CCrystalMarkDlg* P;

/////////////////////////////////////////////////////////////////////////////
// CInfoDlg _CAO


CInfoDlg::CInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInfoDlg::IDD, pParent)
{
	P = (CCrystalMarkDlg*)pParent;
	SysInfo = ((CCrystalMarkDlg*)pParent)->SysInfo;

	//{{AFX_DATA_INIT(CInfoDlg)
	m_InfoCrystalMarkDate = _T("");
	m_InfoCrystalMarkVersion = _T("");
	m_InfoSysInfoDate = _T("");
	m_InfoSysInfoVersion = _T("");
	m_InfoCrystalMarkDllDate = _T("");
	m_InfoFileName = _T("");
	m_InfoImageSize = _T("");
	m_InfoWindowSize = _T("");
	m_InfoTextColor = _T("");
	m_InfoCrystalMarkDllVersion = _T("");
	//}}AFX_DATA_INIT
}


void CInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInfoDlg)
	DDX_Control(pDX, IDC_INFO_IMAGE_SIZE, m_InfoImageSizeC);
	DDX_Control(pDX, IDC_INFO_FILE_NAME, m_InfoFileNameC);
	DDX_Control(pDX, IDC_INFO_CRYSTAL_DEW_WORLD, m_InfoCrystalDewWorldC);
	DDX_Text(pDX, IDC_INFO_CRYSTAL_MARK_DATE, m_InfoCrystalMarkDate);
	DDX_Text(pDX, IDC_INFO_CRYSTAL_MARK_VERSION, m_InfoCrystalMarkVersion);
	DDX_Text(pDX, IDC_INFO_SYS_INFO_DATE, m_InfoSysInfoDate);
	DDX_Text(pDX, IDC_INFO_SYS_INFO_VERSION, m_InfoSysInfoVersion);
	DDX_Text(pDX, IDC_INFO_CRYSTAL_MARK_DLL_DATE, m_InfoCrystalMarkDllDate);
	DDX_Text(pDX, IDC_INFO_FILE_NAME, m_InfoFileName);
	DDX_Text(pDX, IDC_INFO_IMAGE_SIZE, m_InfoImageSize);
	DDX_Text(pDX, IDC_INFO_WINDOW_SIZE, m_InfoWindowSize);
	DDX_Text(pDX, IDC_INFO_TEXT_COLOR, m_InfoTextColor);
	DDX_Text(pDX, IDC_INFO_CRYSTAL_MARK_DLL_VERSION, m_InfoCrystalMarkDllVersion);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CInfoDlg)
	ON_BN_CLICKED(IDC_INFO_CRYSTAL_DEW_WORLD, OnInfoCrystalDewWorld)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_INFO_BACK_MODE, OnInfoBackMode)
	ON_BN_CLICKED(IDC_INFO_CLEAR, OnInfoClear)
	ON_BN_CLICKED(IDC_INFO_SELECT_TEXT_COLOR, OnInfoSelectTextColor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInfoDlg bZ[W nh

void CInfoDlg::OnCancel() 
{
//	CDialog::OnCancel();
}

void CInfoDlg::OnOK() 
{	
//	CDialog::OnOK();
}

BOOL CInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_Font.CreatePointFont(200,"Arial",NULL);
//	m_InfoCreditC.SetFont(&m_Font,TRUE);
	m_InfoCrystalDewWorldC.SetFont(&m_Font,TRUE);

	Internationalise();

	m_InfoCrystalMarkDate = CRYSTAL_MARK_DATE_08;
	m_InfoCrystalMarkVersion = CRYSTAL_MARK_VERSION_08;
	
	char Version[32];
	char Date[32];
	SysInfo->GetString(SI_VERSION,Version);
	SysInfo->GetString(SI_DATE,Date);
	m_InfoSysInfoDate = Date;
	m_InfoSysInfoVersion = "Release ";
	m_InfoSysInfoVersion+= Version;

	GetDllInfo(Version,Date);
	m_InfoCrystalMarkDllVersion = Version;
	m_InfoCrystalMarkDllDate = Date;

	UpdateData(FALSE);

	char str[256];
	GetPrivateProfileString("Setting","BackgroundImage","",str,256,P->m_ini);
	m_InfoFileName = " ";
	m_InfoFileName += str;

	if( ! m_InfoFileName.IsEmpty() && ( P->Dib.LoadBmp(m_InfoFileName)
#ifdef USEPNG
		|| P->Dib.LoadPng(m_InfoFileName) 
#endif
#ifdef USEJPEG
		|| P->Dib.LoadJpeg(m_InfoFileName) 
#endif
		)
	)
	{
		m_InfoImageSize.Format("%d x %d x %d bit", P->Dib.Width(), P->Dib.Height(), P->Dib.Depth() ) ;
	}

	RECT rect;
	GetClientRect(&rect);
	m_InfoWindowSize.Format("%d x %d", rect.right, rect.bottom);

	m_InfoTextColor.Format("RGB( %d, %d, %d )",
		gTextColor & 0x000000FF,
		(gTextColor & 0x0000FF00) >> 8,
		(gTextColor & 0x00FF0000) >> 16
		);

	UpdateData(FALSE);
	UpdateWindow();

	return TRUE;
}


void CInfoDlg::OnInfoCrystalDewWorld() 
{
	ShellExecute(NULL,NULL,URL_CRYSTAL_MARK_08,NULL,NULL,SW_SHOWNORMAL);		
}

void CInfoDlg::Internationalise()
{
}

HBRUSH CInfoDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}

void CInfoDlg::OnInfoBackMode() 
{
	CFileDialog dlg(TRUE,
		"","",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_EXPLORER, 
#ifdef USEJPEG
		"Supported Image Files|*.bmp;*.png;*.jpg;*.jpeg|BMP (*.bmp)|*.bmp|PNG (*.png)|*.png|JPEG (*.jpg *.jpeg)|*.jpg;*.jpeg|All Files (*.*)|*.*||");
//#else USEPNG
//		"Supported Image File|*.bmp;*.png|BMP (*.bmp)|*.bmp|PNG (*.png)|*.png|All Files (*.*)|*.*||");
#else 
		"Supported Image Files|*.bmp|BMP (*.bmp)|*.bmp|All Files (*.*)|*.*||");
#endif

	if( dlg.DoModal() == IDOK )
	{
		m_InfoFileName = dlg.GetPathName();
/*
		if( ! m_InfoFileName.IsEmpty() && ( P->Dib.LoadBmp(m_InfoFileName) 
#ifdef USEPNG
			|| P->Dib.LoadPng(m_InfoFileName)
#endif
#ifdef USEJPEG
			|| P->Dib.LoadJpeg(m_InfoFileName)
#endif
			)
		)
		{
			m_InfoImageSize.Format("%d x %d x %d bit", P->Dib.Width(), P->Dib.Height(), P->Dib.Depth() ) ;
			P->Dib.Destroy();
		}
		UpdateData(FALSE);
		m_InfoImageSizeC.ShowWindow(SW_HIDE);
		m_InfoImageSizeC.ShowWindow(SW_SHOW);
		m_InfoFileNameC.ShowWindow(SW_HIDE);
		m_InfoFileNameC.ShowWindow(SW_SHOW);
		UpdateWindow();
*/
		WritePrivateProfileString("Setting","BackgroundImage",m_InfoFileName,P->m_ini);
		P->CreateWallPaper(1,NULL,(char*)(const char*)m_InfoFileName,0);
		UpdateWindow();
		Invalidate(TRUE);
	}
}

void CInfoDlg::OnInfoClear() 
{
	WritePrivateProfileString("Setting","BackgroundImage","",P->m_ini);
	WritePrivateProfileString("Setting","TextColor","",P->m_ini);

	gTextColor = ::GetSysColor(COLOR_WINDOWTEXT);
	m_InfoTextColor.Format("RGB( %d, %d, %d )",
		gTextColor & 0x000000FF,
		(gTextColor & 0x0000FF00) >> 8,
		(gTextColor & 0x00FF0000) >> 16
		);
	m_InfoFileName = "";
	m_InfoImageSize = "";
	UpdateData(FALSE);

	P->CreateWallPaper(0,NULL,(char*)(const char*)m_InfoFileName,0);
	Invalidate(TRUE);
}

void CInfoDlg::OnInfoSelectTextColor() 
{
	CColorDialog dlg;
	if( dlg.DoModal() == IDOK )
	{
		gTextColor = dlg.GetColor();
		CString cstr;
		cstr.Format("%d",gTextColor);
		m_InfoTextColor.Format("RGB( %d, %d, %d )",
			gTextColor & 0x000000FF,
			(gTextColor & 0x0000FF00) >> 8,
			(gTextColor & 0x00FF0000) >> 16
			);
		UpdateData(FALSE);
		WritePrivateProfileString("Setting","TextColor",cstr,P->m_ini);
		Invalidate(TRUE);
	}
}
