#include "stdafx.h"

#ifndef CRYSTAL_SYS_INFO

#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "MarkDlg.h"
#include "../CrystalMarkDll/CrystalMarkDll.h"
#include "../CrystalMarkShare/Share.h"
#include "Bench.h"

#pragma comment(lib, "CrystalMark08.lib")

#include <process.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL FlagExit = FALSE;
static CCrystalMarkDlg* P;

void ExecBenchMark(void* Status);

/////////////////////////////////////////////////////////////////////////////
// CMarkDlg _CAO


CMarkDlg::CMarkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMarkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMarkDlg)
	m_MarkOptionFontSmoothing = _T("");
	m_MarkOptionDisplayMode = _T("");
	//}}AFX_DATA_INIT
	P = (CCrystalMarkDlg*)pParent;

	m_MarkSubDlg = NULL;
	m_MarkSubDlg = new CMarkSubDlg(this);

#ifdef USE_OPTION
	m_MarkOptionDlg = NULL;
	m_MarkOptionDlg = new CMarkOptionDlg(this);
#endif

	// ʔz̏
	int i,j;
	for(i=0;i<=10;i++){
		m_Flag[i] = FALSE;
		for(j=0;j<16;j++){
			D[i][j] = 0;
			R[i][j] = 0;
			V[i][j] = 0;
		}
	}
}

CMarkDlg::~CMarkDlg()
{
	if(m_MarkSubDlg != NULL){delete m_MarkSubDlg;}
#ifdef USE_OPTION
	if(m_MarkOptionDlg != NULL){delete m_MarkOptionDlg;}
#endif
}

void CMarkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMarkDlg)
	DDX_Control(pDX, IDC_MARK_OPTION_FONT_SMOOTHING, m_MarkOptionFontSmoothingC);
	DDX_Control(pDX, IDC_MARK_OPTION_DISPLAY_MODE, m_MarkOptionDisplayModeC);
	DDX_Control(pDX, IDC_MARK_OPTION_PROCESSOR_MASK, m_MarkOptionProcessorMask);
	DDX_Control(pDX, IDC_MARK_OPTION_HDD_SIZE, m_MarkOptionHDDSize);
	DDX_Control(pDX, IDC_MARK_OPTION_HDD_SELECT, m_MarkOptionHDDSelect);
	DDX_Control(pDX, IDC_MARK_OGL_SCORE, m_MarkOGLScoreC);
	DDX_Control(pDX, IDC_MARK_OGL, m_MarkOGLC);
	DDX_Control(pDX, IDC_MARK_MEM_SCORE, m_MarkMEMScoreC);
	DDX_Control(pDX, IDC_MARK_NET_SCORE, m_MarkNETScoreC);
	DDX_Control(pDX, IDC_MARK_MMT_SCORE, m_MarkMMTScoreC);
	DDX_Control(pDX, IDC_MARK_MARK_SCORE, m_MarkMarkScoreC);
	DDX_Control(pDX, IDC_MARK_HDD_SCORE, m_MarkHDDScoreC);
	DDX_Control(pDX, IDC_MARK_GDI_SCORE, m_MarkGDIScoreC);
	DDX_Control(pDX, IDC_MARK_FPU_SCORE, m_MarkFPUScoreC);
	DDX_Control(pDX, IDC_MARK_D3D_SCORE, m_MarkD3DScoreC);
	DDX_Control(pDX, IDC_MARK_D2D_SCORE, m_MarkD2DScoreC);
	DDX_Control(pDX, IDC_MARK_ALU_SCORE, m_MarkALUScoreC);
	DDX_Control(pDX, IDC_MARK_STOP, m_MarkStopC);
	DDX_Control(pDX, IDC_MARK_NET, m_MarkNETC);
	DDX_Control(pDX, IDC_MARK_MMT, m_MarkMMTC);
	DDX_Control(pDX, IDC_MARK_MEM, m_MarkMEMC);
	DDX_Control(pDX, IDC_MARK_MARK, m_MarkMarkC);
	DDX_Control(pDX, IDC_MARK_HDD, m_MarkHDDC);
	DDX_Control(pDX, IDC_MARK_GDI, m_MarkGDIC);
	DDX_Control(pDX, IDC_MARK_FPU, m_MarkFPUC);
	DDX_Control(pDX, IDC_MARK_D3D, m_MarkD3DC);
	DDX_Control(pDX, IDC_MARK_D2D, m_MarkD2DC);
	DDX_Control(pDX, IDC_MARK_ALU, m_MarkALUC);
	DDX_Control(pDX, IDC_MARK_TAB, m_MarkTab);
	DDX_Text(pDX, IDC_MARK_OPTION_FONT_SMOOTHING, m_MarkOptionFontSmoothing);
	DDX_Text(pDX, IDC_MARK_OPTION_DISPLAY_MODE, m_MarkOptionDisplayMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMarkDlg, CDialog)
	//{{AFX_MSG_MAP(CMarkDlg)
	ON_BN_CLICKED(IDC_MARK_ALU, OnMarkAlu)
	ON_NOTIFY(TCN_SELCHANGE, IDC_MARK_TAB, OnSelchangeMarkTab)
	ON_BN_CLICKED(IDC_MARK_MARK, OnMarkMark)
	ON_BN_CLICKED(IDC_MARK_STOP, OnMarkStop)
	ON_BN_CLICKED(IDC_MARK_FPU, OnMarkFpu)
	ON_BN_CLICKED(IDC_MARK_MEM, OnMarkMem)
	ON_BN_CLICKED(IDC_MARK_HDD, OnMarkHdd)
	ON_BN_CLICKED(IDC_MARK_GDI, OnMarkGdi)
	ON_BN_CLICKED(IDC_MARK_MMT, OnMarkMmt)
	ON_BN_CLICKED(IDC_MARK_D2D, OnMarkD2d)
	ON_BN_CLICKED(IDC_MARK_D3D, OnMarkD3d)
	ON_BN_CLICKED(IDC_MARK_NET, OnMarkNet)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_MARK_OGL, OnMarkOgl)
	ON_CBN_SELCHANGE(IDC_MARK_OPTION_PROCESSOR_MASK, OnSelchangeMarkOptionProcessorMask)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMarkDlg bZ[W nh

void CMarkDlg::OnOK() 
{
//	CDialog::OnOK();
}

void CMarkDlg::OnCancel() 
{
//	CDialog::OnCancel();
}

BOOL CMarkDlg::IsEntryOK()
{
	int count=0;

	if(m_FlagEntry != TRUE){return FALSE;}
	if(D[0][0] == 0){return FALSE;}

	for(int i=6;i<=7;i++){
		if(	D[0][0] == D[i][0] && D[0][1] == D[i][1]
		&&  D[0][2] == D[i][2] && D[0][3] == D[i][3]){
			count++;
		}
	}

	if(count == 2){return TRUE;}
	else{return FALSE;}
}

BOOL CMarkDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_FlagEntry = FALSE;
/*	ʃ[h͕̏KvȂ
	m_MarkOptionDisplayMode = P->m_DeviceDlg->m_DeviceDisplayMode;
	m_MarkOptionFontSmoothing = P->m_DeviceDlg->m_DeviceFontSmoothing;
	UpdateData(FALSE);
*/
	m_Mater[0] = &m_MarkMarkScoreC;
	m_Mater[1] = &m_MarkALUScoreC;
	m_Mater[2] = &m_MarkFPUScoreC;
	m_Mater[3] = &m_MarkMEMScoreC;
	m_Mater[4] = &m_MarkHDDScoreC;
	m_Mater[5] = &m_MarkMMTScoreC;
	m_Mater[6] = &m_MarkGDIScoreC;
	m_Mater[7] = &m_MarkD2DScoreC;
	m_Mater[8] = &m_MarkD3DScoreC;
	m_Mater[9] = &m_MarkNETScoreC;
	m_Mater[10]= &m_MarkOGLScoreC;


	for(int i=0;i<=10;i++)
	{
		m_Mater[i]->SetMaxWidth(20000);
		m_Mater[i]->SetWidth(R[0][i]);
	}
	m_Mater[0]->SetMaxWidth(100000);
/*
	m_MarkMarkScoreC.SetString("CrystalMark08");
	m_MarkALUScoreC.SetString("sӐ쒆");
	m_MarkFPUScoreC.SetString("2003 N 3  31 ");
	m_MarkMEMScoreC.SetString("Cache ΉH");
	m_MarkHDDScoreC.SetString("RAID ͂ǂȂ...");
	m_MarkGDIScoreC.SetString("BitBlt Ή");
	m_MarkMMTScoreC.SetString("Multi Media Test");
	m_MarkD2DScoreC.SetString(" Multi Thread");
	m_MarkD3DScoreC.SetString("D3D");
	m_MarkNETScoreC.SetString(".Net Framework");
*/
/*
	m_MarkMarkScoreC.SetWidth(256);
	m_MarkALUScoreC.SetWidth(240);
	m_MarkFPUScoreC.SetWidth(220);
	m_MarkMEMScoreC.SetWidth(200);
	m_MarkHDDScoreC.SetWidth(180);
	m_MarkGDIScoreC.SetWidth(160);
	m_MarkMMTScoreC.SetWidth(140);
	m_MarkD2DScoreC.SetWidth(120);
	m_MarkD3DScoreC.SetWidth(100);
	m_MarkNETScoreC.SetWidth(80);


	CFont *pFont = new CFont;
	pFont->CreatePointFont(200,"lr oSVbN",NULL);
	m_MarkMarkScoreC.SetFont(pFont,TRUE);
	m_MarkALUScoreC.SetFont(pFont,TRUE);
	m_MarkFPUScoreC.SetFont(pFont,TRUE);
	m_MarkMEMScoreC.SetFont(pFont,TRUE);
	m_MarkHDDScoreC.SetFont(pFont,TRUE);
	m_MarkGDIScoreC.SetFont(pFont,TRUE);
	m_MarkMMTScoreC.SetFont(pFont,TRUE);
	m_MarkD2DScoreC.SetFont(pFont,TRUE);
	m_MarkNETScoreC.SetFont(pFont,TRUE);
	m_MarkD3DScoreC.SetFont(pFont,TRUE);
*/
//	m_MarkALUC.SetIcon(AfxGetApp()->LoadIcon(IDI_ICON1));
//	SetWindowLong(m_MarkALUC.m_hWnd,GWL_STYLE,0x5001000B);

	// Processor Mask ̐ݒ
	CString cstr;
	SYSTEM_INFO sysInfo;
	GetSystemInfo(&sysInfo);

	// 4 vZbT܂őΉ
	if( sysInfo.dwNumberOfProcessors == 1 || sysInfo.dwNumberOfProcessors > 4 )
	{
		m_MarkOptionProcessorMask.EnableWindow(FALSE);
	}
		
	if( sysInfo.dwNumberOfProcessors >= 1 ){
		m_MarkOptionProcessorMask.AddString("0001");
	}
	if( sysInfo.dwNumberOfProcessors >= 2 ){
		m_MarkOptionProcessorMask.AddString("0011");
	}
	if( sysInfo.dwNumberOfProcessors >= 3 ){
		m_MarkOptionProcessorMask.AddString("0111");
	}
	if( sysInfo.dwNumberOfProcessors >= 4 ){
		m_MarkOptionProcessorMask.AddString("0101");
		m_MarkOptionProcessorMask.AddString("1111");
	}
	m_MarkOptionProcessorMask.SetCurSel( m_MarkOptionProcessorMask.GetCount() - 1 );


	m_MarkOptionHDDSize.AddString("128MB");
	m_MarkOptionHDDSize.AddString("256MB");
	m_MarkOptionHDDSize.AddString("512MB");
	m_MarkOptionHDDSize.AddString("1024MB");
	m_MarkOptionHDDSize.SetCurSel(0);
	m_MarkOptionHDDSize.UpdateWindow();

	Internationalise();

//	m_MarkTab.InsertItem(0,"Mark");
//	m_MarkTab.InsertItem(0,"Setting");
	m_MarkTab.InsertItem(1,"ALU");
	m_MarkTab.InsertItem(2,"FPU");
	m_MarkTab.InsertItem(3,"MEM");
	m_MarkTab.InsertItem(4,"HDD");
//	m_MarkTab.InsertItem(5,"MMT");
	m_MarkTab.InsertItem(6,"GDI");
	m_MarkTab.InsertItem(7,"D2D");
//	m_MarkTab.InsertItem(8,"D3D");
//	m_MarkTab.InsertItem(9,"OGL");
//	m_MarkTab.InsertItem(10,".NET");

	AddPage(m_MarkSubDlg,IDD_MARK_SUB_DIALOG);
	SelectTab(0);
	return TRUE;
}

void CMarkDlg::AddPage(CDialog* pDlg,UINT id)
{
	CRect cr;
	m_MarkTab.GetClientRect(cr);
	int width = cr.Width();
	int height = cr.Height();
	m_MarkTab.AdjustRect(FALSE,cr);
	cr.top+=1;
	int x=cr.left,y=cr.top;
	pDlg->Create( id , &m_MarkTab);
	pDlg->SetWindowPos(&wndTop,x,y,0,0,SWP_NOSIZE | SWP_HIDEWINDOW);
}

void CMarkDlg::OnSelchangeMarkTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	SelectTab(m_MarkTab.GetCurSel());
	*pResult = 0;
}

void CMarkDlg::SelectTab(int Tab)
{
	m_MarkTab.SetCurSel(Tab);
	Tab++;
	if(Tab > 4){Tab++;}
	m_MarkSubDlg->SelectTab(Tab);
	m_MarkSubDlg->ShowWindow(TRUE);
}

void CMarkDlg::ChangeAllWindowStatus(BOOL flag,BOOL type)
{
	m_MarkMarkC.EnableWindow(flag);
	m_MarkALUC.EnableWindow(flag);
	m_MarkFPUC.EnableWindow(flag);
	m_MarkMEMC.EnableWindow(flag);
	m_MarkHDDC.EnableWindow(flag);
//	m_MarkMMTC.EnableWindow(flag);
	m_MarkGDIC.EnableWindow(flag);
	m_MarkD2DC.EnableWindow(flag);
//	m_MarkD3DC.EnableWindow(flag);
//	m_MarkNETC.EnableWindow(flag);
//	m_MarkOGLC.EnableWindow(flag);
	m_MarkTab.EnableWindow(flag);
	if(type){
		m_MarkStopC.EnableWindow(! flag);
	}
}

void CMarkDlg::CalcAllScore()
{

}

void CMarkDlg::OnMarkStop() 
{
	FlagExit = TRUE;	
}

void CMarkDlg::MarkStart(DWORD ID) 
{
#ifndef CRYSTAL_SYS_INFO
	m_Flag[ID] = TRUE;
	m_hThread = (unsigned long *)_beginthread(ExecBenchMark,0,(void*)this);
	ChangeAllWindowStatus(FALSE);
#endif
}

void CMarkDlg::OnMarkMark()
{
	m_MarkOptionProcessorMask.GetWindowText(BenchSetting.ProcessorMask);
	GetDisplayMode(BenchSetting.DISP1,BenchSetting.DISP2,BenchSetting.DISP3,BenchSetting.DISP4);
	GetDisplayMode(D[0][0],D[0][1],D[0][2],D[0][3]);
	m_MarkOptionDisplayMode.Format("%d x %d %dbit",D[0][0],D[0][1],D[0][2]);
	BenchSetting.DisplayMode = m_MarkOptionDisplayMode;
	GetFontStatus(m_MarkOptionFontSmoothing);
	BenchSetting.FontSmoothing = m_MarkOptionFontSmoothing;
	UpdateData(FALSE);
	WindowFlash(m_MarkOptionDisplayModeC);
	WindowFlash(m_MarkOptionFontSmoothingC);
	
	for(int i=0;i<=10;i++)
	{
		m_Mater[i]->SetFontColor(RGB(128,128,255),RGB(128,128,255),RGB(128,128,255),RGB(64,64,255));
		m_Mater[i]->SetMaterColor(RGB(240,240,255));
	}	
	MarkStart(0);
}

void CMarkDlg::OnMarkAlu() {MarkStart(1);}
void CMarkDlg::OnMarkFpu() {MarkStart(2);}
void CMarkDlg::OnMarkMem() {MarkStart(3);}
void CMarkDlg::OnMarkHdd() {MarkStart(4);}
void CMarkDlg::OnMarkMmt() {MarkStart(5);}
void CMarkDlg::OnMarkGdi() {MarkStart(6);}
void CMarkDlg::OnMarkD2d() {MarkStart(7);}
void CMarkDlg::OnMarkD3d() {MarkStart(8);}
void CMarkDlg::OnMarkOgl() {MarkStart(9);}
void CMarkDlg::OnMarkNet() {MarkStart(10);}

void CMarkDlg::Internationalise()
{
	// LȃhCuXgAbv
	CString cstr;
	char  szDrives[128];
	char* pDrive;
	GetLogicalDriveStrings( sizeof(szDrives), szDrives );
	pDrive = szDrives;
	m_MarkOptionHDDSelect.ResetContent();
	while( *pDrive )
	{
		int result = GetDriveType(pDrive);
		if(result != DRIVE_FIXED && result != DRIVE_REMOTE
		|| (result == DRIVE_REMOVABLE  && ( pDrive[0] != 'A' || pDrive[0] != 'B' ) ))
		{
			pDrive += strlen( pDrive ) + 1;
			continue;
		}
		int forward = strlen( pDrive );
		pDrive[1] = '\0';
		_strupr(pDrive);// 啶ɕϊ
		cstr = pDrive;
		if(result == DRIVE_FIXED){
			if( gLanguage == JAPANESE ){
				cstr += " : n[hfBXN";
			}else{
				cstr += " : HardDisk";
			}
			char RootPath[4];
			char FileSystem[32];
			RootPath[0] = pDrive[0];RootPath[1] = ':';RootPath[2] = '\\';RootPath[3] = '\0';
			GetVolumeInformation(RootPath,NULL,NULL,NULL,NULL,NULL,FileSystem,sizeof(FileSystem));
			cstr += " ["; cstr += FileSystem; cstr += "]";
			m_MarkOptionHDDSelect.AddString(cstr);
		}
//		else if(result == DRIVE_REMOTE){cstr += " : lbg[N";}
//		else if(result == DRIVE_REMOVABLE){cstr += " : [ou";}
//		else{cstr += " : s";}
		pDrive += forward + 1;
	}

	m_MarkOptionHDDSelect.SetCurSel(0);
	m_MarkOptionHDDSelect.UpdateWindow();
}

HBRUSH CMarkDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}

//void CMarkDlg::OnMarkResultCopy(){P->Copy("standard.txt",0,0);}
//void CMarkDlg::OnMarkResultHtml(){P->Copy("standard.html",1,0);}

typedef int(WINAPI * _SetProcessAffinityMask_)(void*, DWORD);

void CMarkDlg::OnSelchangeMarkOptionProcessorMask() 
{
	CString cstr;
	m_MarkOptionProcessorMask.GetWindowText(cstr);

	DWORD mask;
	if(cstr == "0001"){mask = 0x1;}
	if(cstr == "0011"){mask = 0x3;}
	if(cstr == "0101"){mask = 0x5;}
	if(cstr == "0111"){mask = 0x7;}
	if(cstr == "1111"){mask = 0xF;}

	if( IsWinNT() ){
		_SetProcessAffinityMask_ SetProcessAffinityMask = NULL;
		SetProcessAffinityMask = (_SetProcessAffinityMask_) GetProcAddress (GetModuleHandle("kernel32"),"SetProcessAffinityMask");

		if( SetProcessAffinityMask != NULL ){
			mask = SetProcessAffinityMask(GetCurrentProcess(),mask);
		//	cstr.Format("%X",mask);MessageBox(cstr);
		}
	}
}

#endif // #ifndef CRYSTAL_SYS_INFO
