#include "stdafx.h"

#ifndef CRYSTAL_SYS_INFO

#include "crystalmark.h"
#include "MarkDlg.h"
#include "MarkSubDlg.h"
#include "Bench.h"

#include "../CrystalMarkDll/CrystalMarkDll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMarkSubDlg _CAO

static CMarkDlg* Mark;

CMarkSubDlg::CMarkSubDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMarkSubDlg::IDD, pParent)
{
	Mark = (CMarkDlg*)pParent;
	//{{AFX_DATA_INIT(CMarkSubDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}

CMarkSubDlg::~CMarkSubDlg()
{
	if( m_pFont != NULL){delete m_pFont;}
}

void CMarkSubDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMarkSubDlg)
	DDX_Control(pDX, IDC_MARK_SUB_LIST, m_MarkSubList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMarkSubDlg, CDialog)
	//{{AFX_MSG_MAP(CMarkSubDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_MARK_SUB_LIST, OnDblclkMarkSubList)
//	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMarkSubDlg bZ[W nh

void CMarkSubDlg::OnCancel() 
{
//	CDialog::OnCancel();
}

void CMarkSubDlg::OnOK() 
{
//	CDialog::OnOK();
}

BOOL CMarkSubDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pFont = new CFont;
	m_pFont->CreatePointFont( 100 ,"Arial",NULL);
	m_MarkSubList.SetFont(m_pFont,TRUE);

// Xgr[̍\z
	LVCOLUMN myColumn;
	myColumn.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER ;

	// Rg[̕擾
	CRect cr;m_MarkSubList.GetClientRect(cr);
	DWORD width = m_listwidth = cr.Width();// - GetSystemMetrics(SM_CXVSCROLL);

	double comctl32 = GetFileVersion("comctl32.dll");
	if( comctl32 >= 4.70 ){
		long dwStyle = ListView_GetExtendedListViewStyle(m_MarkSubList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_MarkSubList.m_hWnd, dwStyle);
	}
	if( comctl32 >= 4.71 ){
		m_MarkSubList.GetHeaderCtrl()->EnableWindow(FALSE);
	}
	m_MarkSubList.InsertColumn(0,"Item",LVCFMT_LEFT,width * 55 / 100,0);
	SelectTab(0);
	return TRUE;
}

void CMarkSubDlg::SelectTab(int Type)
{
	m_MarkSubList.DeleteAllItems();
	m_MarkSubList.DeleteColumn(2);
	m_MarkSubList.DeleteColumn(1);

	CString cstr1,cstr2;
	char str[256];
	CString unit;
	LVITEM myItem;
	memset(&myItem,0,sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;
	if(Type == 3 || Type == 4){unit = "MB/s";}
	else if(Type == 7 || Type == 8 || Type == 9){unit = "FPS";}
	else {unit = "Score";}

	if( Type == 3 || Type == 4 || Type == 7 || Type == 8 || Type == 9 ){
		m_MarkSubList.InsertColumn(1,unit,LVCFMT_RIGHT,m_listwidth * 25 / 100,0);
		m_MarkSubList.InsertColumn(2,"Score",LVCFMT_RIGHT,m_listwidth * 20 / 100,0);
	}else{
		m_MarkSubList.InsertColumn(1,unit,LVCFMT_RIGHT,m_listwidth * 45 / 100,0);
	}

	for(int Number=0;Number<16;Number++){
		GetBenchString(Type,Number,str);
		if( strcmp(str,"") != 0){
			myItem.iItem = Number;
			myItem.iSubItem = 0;
			myItem.pszText = str;
			m_MarkSubList.InsertItem(&myItem);

			if(Mark->R[Type][Number] >= 0){
				switch (Type)
				{
				case 3:// MEM
				case 4:// HDD
				case 7:// D2D
				case 8:// D3D
				case 9:// OGL
					cstr1.Format("%.2f",Mark->V[Type][Number] / 100.0);
					cstr2.Format("%d",Mark->R[Type][Number]);
					break;
				default:
					cstr1.Format("%d",Mark->V[Type][Number]);
					cstr2 = "";
					break;
				}
			}
			Mark->m_MarkSubDlg->m_MarkSubList.SetItemText(Number,1,cstr1);
			if( Type == 3 || Type == 4 || Type == 7 || Type == 8 || Type == 9 ){
				Mark->m_MarkSubDlg->m_MarkSubList.SetItemText(Number,2,cstr2);
			}
		}
	}
}

void CMarkSubDlg::OnDblclkMarkSubList(NMHDR* pNMHDR, LRESULT* pResult) 
{
/*
// P̃eXg
#ifndef CRYSTAL_SYS_INFO
	DWORD dwPos = ::GetMessagePos();
	CPoint point ((int)LOWORD(dwPos),(int)HIWORD(dwPos));
	m_MarkSubList.ScreenToClient(&point);
	
	int result = m_MarkSubList.HitTest(point);
	if( result != -1){
		ExecBenchMarkSub(P,Mark->m_MarkTab.GetCurSel(),result);
	}
#endif
*/
	*pResult = 0;
}

#endif // #ifndef CRYSTAL_SYS_INFO
